<?php
/*
Simple:Press Forum
Blog Linking - Blog side support routines
$LastChangedDate: 2010-01-23 09:58:40 -0700 (Sat, 23 Jan 2010) $
$Rev: 3307 $
*/

if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) {
	die('Access Denied');
}

include_once(SF_PLUGIN_DIR.'/linking/forms/sf-form-blog-link.php');
include_once(SF_PLUGIN_DIR.'/linking/library/sf-links-support.php');

# ------------------------------------------------------------------
# sf_save_blog_link()
#
# Filter call
# Called on  a Post Save to create the blog/forum Link
#	$postid		id of the blog post to link to
# ------------------------------------------------------------------
function sf_save_blog_link($postid)
{
	if(isset($_POST['sflink']))
	{
		# test if revision
		$checkpost=wp_is_post_revision($postid);
		if($checkpost != false) $postid=$checkpost;

		$forumid = sf_esc_int($_POST['sfforum']);

		# sadly need to check if both items already set (forum @ topic)
		$links = sf_blog_links_control('read', $postid);
		if(($links) && ($links->forum_id != 0 && $links->topic_id != 0))
		{
			# already cooked
			return;
		} else {
			sf_blog_links_control('save', $postid, $forumid);
		}
	}
	return;
}

# ------------------------------------------------------------------
# sf_publish_blog_link()
#
# Filter call
# Called on  a Post Publish to create the blog/forum Link
#	$post		The Actual Post Object
# ------------------------------------------------------------------
function sf_publish_blog_link($post)
{
	global $wpdb;

	# Check post status for published as it calls this hook regardless of state
	if($post->post_status != 'publish') return;

	$links = sf_blog_links_control('read', $post->ID);

	if(isset($_POST['sflink']) || $links)
	{
		# sadly need to check if both items already set (forum & topic)
		if(($links) && ($links->forum_id != 0 && $links->topic_id != 0))
		{
			return;
		} else {
			# get the correct forum id first
			if(isset($_POST['sfforum']))
			{
				$forumid = sf_esc_int($_POST['sfforum']);
			} else {
				$forumid = $links->forum_id;
			}
			# first - get the options
			$sfpostlinking = array();
			$sfpostlinking = sf_get_option('sfpostlinking');

			$post_title = sf_filter_title_save($post->post_title);
			$slug = sf_create_slug($post_title, 'topic');
			$now = current_time('mysql');

			# now create the topic and post records - it should already be escaped fully.
			$sql = "INSERT INTO ".SFTOPICS." (topic_name, topic_slug, topic_date, forum_id, user_id, post_count, blog_post_id, post_id) VALUES ('".$post_title."', '".$slug."', '".$now."', ".$forumid.", ".$post->post_author.", 1, ".$post->ID.", ".$post->ID.");";
			$wpdb->query($sql);

			$topicid = $wpdb->insert_id;

			# check the topic slug and if empty use the topic id
			if(empty($slug))
			{
				$slug = 'topic-'.$topicid;
				$thistopic = $wpdb->query("
					UPDATE ".SFTOPICS."
					SET topic_slug='".$slug."', topic_name='".$slug."'
					WHERE topic_id=".$topicid);
			}

			$postcontent = sf_prepare_linked_topic_content($post->post_content, $post->post_excerpt, $sfpostlinking);

			$sql = "INSERT INTO ".SFPOSTS." (post_content, post_date, topic_id, user_id, forum_id) VALUES ('".$postcontent."', '".$now."', ".$topicid.", ".$post->post_author.", ".$forumid.");";
			$wpdb->query($sql);

			$sfedit = false;
			if($_POST['sfedit']) $sfedit = true;
			# and then update links table with forum AND topic
			sf_blog_links_control('save', $post->ID, $forumid, $topicid, $sfedit);
			# Update authors forum post count
			$postcount = (sf_get_member_item($post->post_author, 'posts')+1);
			sf_update_member_item($post->post_author, 'posts', $postcount);

			# Update forum, topic and post index data
			sf_build_forum_index(sf_esc_int($forumid));
			sf_build_post_index($topicid, $slug);
		}
	}
	return;
}

# ------------------------------------------------------------------
# sf_prepare_linked_topic_content()
#
# prepares blog post content for the topic post
# 	$content		full content o the blog post
#	$excerpt		excerpt of the blog post
#	$sfpostlinking	link options
# ------------------------------------------------------------------
function sf_prepare_linked_topic_content($content, $excerpt, $sfpostlinking)
{
	$content = sf_filter_content_save($content, 'new');

	switch($sfpostlinking['sflinkexcerpt'])
	{
		case 3:
		$postcontent = sf_filter_content_save($post->post_excerpt, 'new');
		break;

		case 2:
		$postcontent = sf_make_excerpt($content, $sfpostlinking['sflinkwords']);
		break;

		default:
		$postcontent = $content;
		break;
	}

	return $postcontent;
}

# ------------------------------------------------------------------
# sf_update_blog_link()
#
# Filter call
# Called on a Post Edit to u[date the blog/forum Link
#	$postid		id of the blog post to link to
# ------------------------------------------------------------------
function sf_update_blog_link($postid)
{
	global $wpdb;

	# This could be an update to post content OR a new link on existing post so check
	# If new link on exisiting post this gets run before the 'save_post' hook so we need to force a save post first
	sf_save_blog_link($postid);

	$links = sf_blog_links_control('read', $postid);

	if($links && $links->topic_id == 0)
	{
		# then a new link on existing blog post so get post object
		$postrecord = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."posts WHERE ID=".$postid);
		if($postrecord)
		{
			sf_publish_blog_link($postrecord);
			return;
		}
	}

	# probably an edit to content then
	if((isset($_POST['sfedit']) && $_POST['sfedit'] == true) || $links->syncedit == true)
	{
		$post = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."posts WHERE ID=".$postid);
		if($post)
		{
			# first - get the options
			$sfpostlinking = array();
			$sfpostlinking = sf_get_option('sfpostlinking');

			$postcontent = sf_prepare_linked_topic_content($post->post_content, $post->post_excerpt, $sfpostlinking);

			$sql = "UPDATE ".SFPOSTS." SET post_content='".$postcontent."' WHERE topic_id=".$links->topic_id." AND post_index=1";
			$wpdb->query($sql);
		}
	}
	return;
}

# ------------------------------------------------------------------
# sf_show_blog_link()
#
# Filter call
# Adds the user-defined link text to a blog post
#	$content	The content of the target post
# ------------------------------------------------------------------
if(!function_exists('sf_show_blog_link')):
function sf_show_blog_link($content)
{
	global $wp_query;

	$postid = $wp_query->post->ID;
	$links = sf_blog_links_control('read', $postid);
	if(!$links) return $content;

	#show only on single pages?
	$sfpostlinking = sf_get_option('sfpostlinking');
	if ($sfpostlinking['sflinksingle'] && !is_single()) return $content;

	$out = sf_transform_bloglink_label($postid, $links, true);

	if($sfpostlinking['sflinkabove'])
	{
		return $out.$content;
	} else {
		return $content.$out;
	}
}
endif;

# ------------------------------------------------------------------
# sf_delete_blog_link()
#
# Action call
# Removes forum link if blog post is deleted
#	$postid		ID of the post being deleted
# ------------------------------------------------------------------
function sf_delete_blog_link($postid)
{
	include_once(SF_PLUGIN_DIR.'/linking/sf-links-forum.php');

	$links = sf_blog_links_control('read', $postid);
	if($links)
	{
		# Check - this might be a Revision record
		if($links->forum_id != 0)
		{
			sf_break_blog_link($links->topic_id, $postid);
		}
	}
	return;
}

# ------------------------------------------------------------------
# sf_add_admin_link_column()
#
# Filter call
# Adds link column to edit posts/pages
# ------------------------------------------------------------------
function sf_add_admin_link_column($defaults)
{
    $defaults['spflinked'] = __('Forum Linked');
    return $defaults;
}

# ------------------------------------------------------------------
# sf_add_admin_link_column()
#
# Action call
# Displays link column info in edit posts/pages
# ------------------------------------------------------------------
function sf_show_admin_link_column($column, $postid)
{
	if($column == 'spflinked')
	{
		$links = sf_blog_links_control('read', $postid);
		if($links)
		{
			echo __("Linked to forum", "sforum").':<br />'.sf_get_forum_name_from_id($links->forum_id);
		}
	}
}

?>