<?php
include_once '/var/www/sites/basic/Member.php';
include_once '/var/www/sites/basic/Note.php';
include_once '/var/www/sites/basic/smsSOAP.php';

session_start();
$errors = array();

function _login($username, $password) {
		if ($username == '' || $password == '') $errors[] = "Du må skrive inn ditt brukernavn og passord";
		else {
			$member = new Member();
			$member->getMember($username);
			
			if (!isset($member->id) || $member->id == 0) { //Feil brukernavn
				$errors[] = "Feil brukernavn eller passord. Prøv igjen.";
			}
			else if (!comparePassword($password, $member->password)) { //Feil passord
				$errors[] = "Feil brukernavn eller passord. Prøv igjen.";
			}
			else {
				$smscode = _generateCode();
				$smscodetimestamp = time();
				
				$message = "Din midlertidige kode for å logge inn på Mobesity-sidene er: " 
						. $smscode . ". Koden er gyldig i 10 minutter.";
				
				/*****************DEBUGMODE=OFF***************************/
				$isSentSms = _sendSms($member->tlf, $message); //true
				/*****************************************************/
				
				if ($isSentSms) {
					$member->updateSms($smscode, $smscodetimestamp);
					return true;
				}
				else {
					$errors[] = "Det har oppstått en feil under sending av SMS. Kan ikke fortsette til steg 2.";
				}
			}
		}
		$_SESSION['errors'] = $errors[0];
		return false;
}

function _login2($codeInput) {
	if ($codeInput == '') $errors[] = "Du må skrive inn koden du fikk på SMS for å fortsette";
	else {
		    $member = new Member();
			$member->getMemberBySession(session_id());
			
			$codeStored = (int) $member->smscode;
			$timestampStored = (int) $member->smscodetimestamp;
			$timestampInput = (int) time();
			
			if ($timestampInput < ($timestampStored + 600)) {
				/*****************DEBUGMODE=OFF***********************/
				if ($codeInput == $codeStored) { //if (true) { 
				/*****************************************************/
					$_SESSION['isLoggedIn'] = true;
					$member->updateAccess();
					return true;
				} else {
					$errors[] = "SMS-koden stemmer ikke.";
				}
			} else {
				$errors[] = "SMS-koden er ikke lenger gyldig. Du må logge inn på nytt <a href='login.php'>her</a>";
			}
	}
	$_SESSION['errors'] = $errors[0];
	return false;
}
/**
* Method for updating a user
* Not implemented
*/
function updateUser($username, $password, $password2, $tlf, $firstname, $surname, $email, $role) {

}
/**
* Method for updating a users password
*/
function updateUserPw($oldpassword, $password, $password2) {
	if ($oldpassword == '' || $password == '' || $password2 == '') {
		$errors[] = "<div id='errorMsg'>Alle feltene må være fylt ut</div>";
		return $errors;
	}
	$member = new Member();
	$member->getMemberBySession(session_id());
	
	if (!comparePassword($oldpassword, $member->password)) { //Feil passord
		$errors[] = "Feil passord. Prøv igjen.";
		return $errors;
	}
	if ($password == $password2) {
		//Salt and hash password
		$hash = getPasswordHash( getPasswordSalt(), $password );
		
		$success = $member->updateMemberPw($hash);
		if ($success) $errors[] = "<div id='successMsg'>Passordet er oppdatert.</div>";
		else {
			$errors[] = "<div id='errorMsg'>Det har oppstått en feil.</div>";
		}
	}
	else {
		$errors[] = "<div id='errorMsg'>Skriv inn samme nye passord to ganger.</div>";
	}

	return $errors;
}
/**
* The mother of all methods! 
* Checks if the Session has timed out and if the user is valid/authorized
*/
function _checkSession($roleInput = 'user') {
	$member = new Member();
	$member->getMemberBySession(session_id());
	
	//Redirect to login.php if the user does not exist based on the session.
	if ($member == null || $member->id == 0 || $member->id == null) {
		$url = 'http://' . $_SERVER['SERVER_NAME'] . '/sites/basic/logout.php';
		header( 'Location:' . $url);
		exit;
	}
	//Checks if the user is authorized based on input
	$authorized = false;
	if ($roleInput == 'admin') {
		$role = (int) $member->role;
		if ($role == '3' || $role == '6') $authorized = true;
		else $authorized = false;
	}
	else if ($roleInput == 'user') {
		$authorized = true;
	}
	else if ($roleInput == 'light') {
		$member->updateAccess();
		return true;
	}
	//If user is not logged in, boot
	if ( $_SESSION['isLoggedIn'] != true && $roleInput != 'light') {
		$url = 'http://' . $_SERVER['SERVER_NAME'] . '/sites/basic/logout.php';
		header( 'Location:' . $url);
		exit;
	}
	if ($authorized && $_SESSION['isLoggedIn'] == true) {
		$lastaccess = (int) $member->lastaccess;
		$interval = time()-$lastaccess;
		
		//Check if the user har not timed out or logged in from other computer
		if ($member->ip == $_SERVER['REMOTE_ADDR'] && $interval<600) {
			$member->updateAccess();
			return true;
		} else {
			//TODO: Ideally, we would like to use wordpress' method for logging out like this $url = wp_logout_url("../basic/logout.php");
			//Sadly, this leads to an eternal redirect loop.
			$url = 'http://' . $_SERVER['SERVER_NAME'] . '/sites/basic/logout.php';
			header( 'Location:' . $url);
			exit;
		}
	} else {
		return false;
	}
}
function _logout() {
	$_SESSION['isLoggedIn'] = false;
    $_SESSION = array();                //clear session
	// If it's desired to kill the session, also delete the session cookie.
	// Note: This will destroy the session, and not just the session data!
	if (session_id != "" || isset($_COOKIE[session_name()])) {
		setcookie(session_name(), '', time()-42000, '/');
	}
	//session_regenerate_id();
    unset($_COOKIE[session_id()]); 
	unset($_COOKIE[session_name()]);	//clear cookie
    session_destroy();                  //kill the session
}

/**
* Inserts the member in the system from register.php
* 
*/
function insertMember($username, $password, $password2, $tlf, $firstname, $surname, $email, $role) {
	if ($username == '' || $password == '' || $password2 == '' || $tlf == '' || $firstname == '' || $surname == '' || $role  == '') {
		$errors[] = "<div id='errorMsg'>Alle feltene må være fylt ut</div>";
		return $errors;
	}
	if (!($role == 4 || $role == 5 || $role == 7)) {
		$errors[] = "<div id='errorMsg'>Feil brukerinput</div>";
		return $errors;
	}
	if ($password == $password2) {
        $member = new Member();
		$member->getMember($username);
		
		if (!isset($member->id) || $member->id == 0) {
			//Salt and hash password
			$hash = getPasswordHash( getPasswordSalt(), $password );
			
			$newMember = new Member($username, $hash, $tlf, $firstname, $surname, $email, $role);
			
			$success = $newMember->insertMember();
			if ($success) $errors[] = "<div id='successMsg'>Brukeren er registrert.</div>";
			else {
				$errors[] = "<div id='errorMsg'>Det har oppstått en feil.</div>";
			}
		}
		else {
			$errors[] = "<div id='errorMsg'>Brukernavnet finnes fra før</div>";
		}
	}
	else {
		$errors[] = "<div id='errorMsg'>Skriv inn samme passord to ganger.</div>";
	}

	return $errors;
}

function _getNotebookIdByMemberId($memberid) {
	
	try {
		$mdb2 = db_connect('mobesity');
		
		$sql = 'SELECT notebook_id FROM notebook WHERE member_id=?';
		$types = array('text');
		$sth = $mdb2->prepare($sql, $types);
		$data = array($memberid);
		$result = $sth->execute($data);
		
		if ($result->numRows()==1) {
			$row = $result->fetchRow();
			$notebook_id = $row['notebook_id'];
		}
		if (PEAR::isError($mdb2)) {
			echo die($mdb2->getMessage());
		}
		$mdb2->disconnect();
			
		return $notebook_id;
		
	} catch (Exception $e) {
		printf("Error:getnotebookid: %s\n",$e->__toString());
		return false;
	}

}
function getAllMembers() {
	$member = new Member();
	return $member->getAllDBMembers();
}
function deleteUserByUsername($username) {
	$member = new Member();
    $member->getMember($username);
    $success = $member->deleteDBUser();
	
	if ($success) $errors[] = "<div id='successMsg'>Brukeren er slettet fra systemet.</div>";
	
	return $errors;
}

function _generateCode() {
	return rand(1000, 9999);
}
// get a new salt - 8 hexadecimal characters long
// current PHP installations should not exceed 8 characters
// on dechex( mt_rand() )
// but we future proof it anyway with substr()
function getPasswordSalt()
{
	return substr( str_pad( dechex( mt_rand() ), 8, '0', STR_PAD_LEFT ), -8 );
}

// calculate the hash from a salt and a password
function getPasswordHash( $salt, $password )
{
	return $salt . ( hash( 'whirlpool', $salt . $password ) );
}

// compare a password to a hash
function comparePassword( $password, $hash ) {
	$salt = substr( $hash, 0, 8 );
	
	return $hash == getPasswordHash( $salt, $password );
}
?>