<?php
/**
 * NOTE: This is a copy/paste from /var/www/sites/webcal/includes/user.php
 * NOTE(cont): This is in order to bypass the security check done by webcal
 *
 * Delete a user from the system.
 *
 * This will also delete any of the user's events in the system that have
 * no other participants. Any layers that point to this user
 * will be deleted. Any views that include this user will be updated.
 *
 * @param string $user User to delete
 */
function user_delete_user ( $user ) {
  // Get event ids for all events this user is a participant
  $events = array ();
  $res = dbi_execute ( 'SELECT we.cal_id FROM webcal_entry we, webcal_entry_user weu
    WHERE we.cal_id = weu.cal_id AND weu.cal_login = ?', array ( $user ) );
  if ( $res ) {
    while ( $row = dbi_fetch_row ( $res ) ) {
      $events[] = $row[0];
    }
  }
  // Now count number of participants in each event...
  // If just 1, then save id to be deleted
  $delete_em = array ();
  $evcnt = count ( $events );
  for ( $i = 0; $i < $evcnt; $i++ ) {
    $res = dbi_execute ( 'SELECT COUNT(*) FROM webcal_entry_user ' .
      'WHERE cal_id = ?', array ( $events[$i] ) );
    if ( $res ) {
      if ( $row = dbi_fetch_row ( $res ) ) {
        if ( $row[0] == 1 )
          $delete_em[] = $events[$i];
      }
      dbi_free_result ( $res );
    }
  }
  $delete_emcnt = count ( $delete_em );
  // Now delete events that were just for this user
  for ( $i = 0; $i < $delete_emcnt; $i++ ) {
    dbi_execute ( 'DELETE FROM webcal_entry_repeats WHERE cal_id = ?',
      array ( $delete_em[$i] ) );
    dbi_execute ( 'DELETE FROM webcal_entry_repeats_not WHERE cal_id = ?',
      array ( $delete_em[$i] ) );
    dbi_execute ( 'DELETE FROM webcal_entry_log WHERE cal_entry_id = ?',
      array ( $delete_em[$i] )  );
    dbi_execute ( 'DELETE FROM webcal_import_data WHERE cal_id = ?',
      array ( $delete_em[$i] )  );
    dbi_execute ( 'DELETE FROM webcal_site_extras WHERE cal_id = ?',
      array ( $delete_em[$i] )  );
    dbi_execute ( 'DELETE FROM webcal_entry_ext_user WHERE cal_id = ?',
      array ( $delete_em[$i] )  );
    dbi_execute ( 'DELETE FROM webcal_reminders WHERE cal_id = ?',
      array ( $delete_em[$i] )  );
    dbi_execute ( 'DELETE FROM webcal_blob WHERE cal_id = ?',
      array ( $delete_em[$i] )  );
    dbi_execute ( 'DELETE FROM webcal_entry WHERE cal_id = ?',
      array ( $delete_em[$i] )  );
  }

  // Delete user participation from events
  dbi_execute ( 'DELETE FROM webcal_entry_user WHERE cal_login = ?',
    array ( $user ) );
  // Delete preferences
  dbi_execute ( 'DELETE FROM webcal_user_pref WHERE cal_login = ?',
    array ( $user ) );
  // Delete from groups
  dbi_execute ( 'DELETE FROM webcal_group_user WHERE cal_login = ?',
    array ( $user ) );
  // Delete bosses & assistants
  dbi_execute ( 'DELETE FROM webcal_asst WHERE cal_boss = ?',
    array ( $user ) );
  dbi_execute ( 'DELETE FROM webcal_asst WHERE cal_assistant = ?',
    array ( $user ) );
  // Delete user's views
  $delete_em = array ();
  $res = dbi_execute ( 'SELECT cal_view_id FROM webcal_view WHERE cal_owner = ?',
    array ( $user ) );
  if ( $res ) {
    while ( $row = dbi_fetch_row ( $res ) ) {
      $delete_em[] = $row[0];
    }
    dbi_free_result ( $res );
  }
  $delete_emcnt = count ( $delete_em );
  for ( $i = 0; $i < $delete_emcnt; $i++ ) {
    dbi_execute ( 'DELETE FROM webcal_view_user WHERE cal_view_id = ?',
      array ( $delete_em[$i] ) );
  }
  dbi_execute ( 'DELETE FROM webcal_view WHERE cal_owner = ?',
    array ( $user ) );
  //Delete them from any other user's views
  dbi_execute ( 'DELETE FROM webcal_view_user WHERE cal_login = ?',
    array ( $user ) );
  // Delete layers
  dbi_execute ( 'DELETE FROM webcal_user_layers WHERE cal_login = ?',
    array ( $user ) );
  // Delete any layers other users may have that point to this user.
  dbi_execute ( 'DELETE FROM webcal_user_layers WHERE cal_layeruser = ?',
    array ( $user ) );
  // Delete user
  dbi_execute ( 'DELETE FROM webcal_user WHERE cal_login = ?',
    array ( $user ) );
  // Delete function access
  dbi_execute ( 'DELETE FROM webcal_access_function WHERE cal_login = ?',
    array ( $user ) );
  // Delete user access
  dbi_execute ( 'DELETE FROM webcal_access_user WHERE cal_login = ?',
    array ( $user ) );
  dbi_execute ( 'DELETE FROM webcal_access_user WHERE cal_other_user = ?',
    array ( $user ) );
  // Delete user's categories
  dbi_execute ( 'DELETE FROM webcal_categories WHERE cat_owner = ?',
    array ( $user ) );
  dbi_execute ( 'DELETE FROM webcal_entry_categories WHERE cat_owner = ?',
    array ( $user ) );
  // Delete user's reports
  $delete_em = array ();
  $res = dbi_execute ( 'SELECT cal_report_id FROM webcal_report WHERE cal_login = ?',
    array ( $user ) );
  if ( $res ) {
    while ( $row = dbi_fetch_row ( $res ) ) {
      $delete_em[] = $row[0];
    }
    dbi_free_result ( $res );
  }
  $delete_emcnt = count ( $delete_em );
  for ( $i = 0; $i < $delete_emcnt; $i++ ) {
    dbi_execute ( 'DELETE FROM webcal_report_template WHERE cal_report_id = ?',
      array ( $delete_em[$i] ) );
  }
  dbi_execute ( 'DELETE FROM webcal_report WHERE cal_login = ?',
    array ( $user ) );
    //not sure about this one???
  dbi_execute ( 'DELETE FROM webcal_report WHERE cal_user = ?',
    array ( $user ) );
  // Delete user templates
  dbi_execute ( 'DELETE FROM webcal_user_template WHERE cal_login = ?',
    array ( $user ) );
}
/**
* This method is a rewrite of the method above, only with mdb2. This is done because webcal sucks.
*/
function delete_webcal_user ($user) {
	$mdb2 = db_connect('webcal');
	
	// Get event ids for all events this user is a participant
	$events = array ();
			
	$sql = 'SELECT we.cal_id FROM webcal_entry we, webcal_entry_user weu WHERE we.cal_id = weu.cal_id AND weu.cal_login = ?';
	$types = array('text');
	$sth = $mdb2->prepare($sql, $types);
	$data = array($user);
	$result = $sth->execute($data);
	while ($row = $result->fetchRow()) {
		$events[] = $row['cal_id'];
	}
	// Now count number of participants in each event...
	// If just 1, then save id to be deleted
	$delete_em = array ();
	$evcnt = count ( $events );
	$types = array('int');
	for ( $i = 0; $i < $evcnt; $i++ ) {
		$sql = 'SELECT COUNT(*) FROM webcal_entry_user WHERE cal_id = ?';
		$sth = $mdb2->prepare($sql, $types);
		$data = array($events[$i]);
		$result = $sth->execute($data);

		if ($result->numRows() == 1) {
			$delete_em[] = $events[$i];
			$result->free();
		}
	}
	$delete_emcnt = count( $delete_em );
	// Now delete events that were just for this user
	$mdb2->loadModule('Extended');
	for ( $i = 0; $i < $delete_emcnt; $i++ ) {
		$alldata = array(array('webcal_entry_repeats', 'cal_id', $delete_em[$i]),
						 array('webcal_entry_repeats_not', 'cal_id', $delete_em[$i]),
						 array('webcal_entry_log', 'cal_entry_id', $delete_em[$i]),
						 array('webcal_import_data', 'cal_id', $delete_em[$i]),
						 array('webcal_site_extras', 'cal_id', $delete_em[$i]),
						 array('webcal_entry_ext_user', 'cal_id', $delete_em[$i]),
						 array('webcal_reminders', 'cal_id', $delete_em[$i]),
						 array('webcal_blob', 'cal_id', $delete_em[$i]),
						 array('webcal_entry', 'cal_id', $delete_em[$i])
		);
		foreach ($alldata as $entry) {
			$sqlString = $mdb2->buildManipSQL($entry[0], array($entry[2]), MDB2_AUTOQUERY_DELETE, $entry[1] .' = '. $entry[2]);
			$mdb2->extended->execParam($sqlString);
		}
	}
	// Delete user participation from events, preferences, groups, bosses and assistands
	$alldata = array(array('webcal_entry_user', 'cal_login', $user),
						 array('webcal_user_pref', 'cal_login', $user),
						 array('webcal_group_user', 'cal_login', $user),
						 array('webcal_asst', 'cal_boss', $user),
						 array('webcal_asst', 'cal_assistant', $user)
	);
	foreach ($alldata as $entry) {
		$sqlString = $mdb2->buildManipSQL($entry[0], array($entry[2]), MDB2_AUTOQUERY_DELETE, $entry[1] .' = \''. $entry[2] .'\'');
		$mdb2->extended->execParam($sqlString);
	}
	
    // Delete user's views
    $delete_em = array ();
    $sql = 'SELECT cal_view_id FROM webcal_view WHERE cal_owner = ?';
    $types = array('text');
    $sth = $mdb2->prepare($sql, $types);
    $data = array($user);
    $res = $sth->execute($data);
    if ($res)   {
        while ( $row = $res->fetchRow())    {
            $delete_em = $row['cal_view_id'];
        }
        $res->free();
    }
    $delete_emcnt = count ($delete_em );
    for ($i = 0; $i < $delete_emcnt; $i++)  {
        $sql = 'DELETE FROM webcal_view_user WHERE cal_view_id = ?';
        $types = array('int');
        $sth = $mdb2->prepare($sql, $types);
        $data = array($delete_em[$i]);
        $res = $sth->execute($data);
    }
    
    // Delete them from any other user's views, layers, layers other users may have that point to this user, 
	// delete user, function access, user access, user's categories
	$alldata = array(array('webcal_view', 'cal_owner', $user),
						array('webcal_view_user', 'cal_login', $user),
						array('webcal_user_layers', 'cal_login', $user),
						array('webcal_user_layers', 'cal_layeruser', $user),
						array('webcal_user', 'cal_login', $user),
						array('webcal_access_function', 'cal_login', $user),
						array('webcal_access_user', 'cal_login', $user),
						array('webcal_access_user', 'cal_other_user', $user),
						array('webcal_categories', 'cat_owner', $user),
						array('webcal_entry_categories', 'cat_owner', $user)
						  
	);
	foreach ($alldata as $entry) {
		$sqlString = $mdb2->buildManipSQL($entry[0], array($entry[2]), MDB2_AUTOQUERY_DELETE, $entry[1] .' = \''. $entry[2] .'\'');
		$mdb2->extended->execParam($sqlString);
	}
    
    // Delete user's reports
	$delete_em = array ();
	$sql = 'SELECT cal_report_id FROM webcal_report WHERE cal_login = ?';
	$types = array('text');
	$sth = $mdb2->prepare($sql, $types);
	$data = array($user);
	$res = $sth->execute($data);

	if($res)  {
		while ($row = $res->fetchRow()) {
			$delete_em[] = $row['cal_report_id'];
		}
		$res->free();
	}
   
    $delete_emcnt = count ( $delete_em );
    for ($i = 0; $i < $delete_emcnt; $i++)  {
        $sql = 'DELETE FROM webcal_report_template WHERE cal_report_id = ?';
        $types = array('int');
        $sth = $mdb2->prepare($sql, $types);
        $data = array($delete_em[$i]);
        $res = $sth->execute($data);
    }

	$alldata = array(array('webcal_report', 'cal_login', $user),
						array('webcal_report', 'cal_user', $user),
						array('webcal_user_template', 'cal_login', $user)
						  
	);
	foreach ($alldata as $entry) {
		$sqlString = $mdb2->buildManipSQL($entry[0], array($entry[2]), MDB2_AUTOQUERY_DELETE, $entry[1] .' = \''. $entry[2] .'\'');
		$mdb2->extended->execParam($sqlString);
	}
}
function writeToFile($string) {
		$myFile = "/home/tarjei/test.txt";
		$fh = fopen($myFile, 'a') or die("can't open file");
		fwrite($fh, "- ". $string . " \r \n");
		fclose($fh);
	}
?>