<?php

if ( function_exists('register_sidebar') )
    register_sidebar(array(
		'name' => 'Sidebar Widget Area',
        'before_widget' => '<div id="%1$s" class="widget %2$s">',
        'after_widget' => '</div>',
        'before_title' => '<h4 class="widgettitle">',
        'after_title' => '</h4>',
    ));


function sb_bookmarks($title,$link) {
	?>
		<div class="bookmarks">
			<span>If you have enjoyed this entry. Please feel free to bookmark it using your favorite social bookmarking site</span>
			<ul class="social">
				<li class="df"><a href="http://www.designfloat.com/submit.php?url=<?=$link?>&amp;title=<?=$title?>" rel="nofollow">DesignFloat</a></li>
				<li class="del"><a href="http://del.icio.us/post?url=<?=$link?>&amp;title=<?=$title?>" rel="nofollow">Delicious</a></li>
				<li class="digg"><a href="http://digg.com/submit?phase=2&amp;url=<?=$link?>&amp;title=<?=$title?>" rel="nofollow">Digg</a></li>
				<li class="su"><a href="http://www.stumbleupon.com/submit?url=<?=$link?>&amp;title=<?=$title?>" rel="nofollow">StumbleUpon</a></li>
				<li class="techno"><a href="http://technorati.com/faves?add=<?=$link?>" rel="nofollow">Technorati</a></li>
			</ul>
		</div>
	<?
}

function sb_rss_widget($args) {
extract($args);
?>
			<div class="widget widget_rssfeed">
				<ul>
				    <? if (get_option('sb_feedburner')): ?> <li class="rss"><a href="<?php echo "http://feeds2.feedburner.com/".get_option('sb_feedburner'); ?>">Subscribe to RSS Feed</a></li> 
				    <? else: ?> <li class="rss"><a href="<?php bloginfo('rss2_url'); ?>">Subscribe to RSS Feed</a></li> <? endif; ?>
					
					<? if (get_option('sb_email') && get_option('sb_feedburner')) { ?><li class="email"><a href="http://feedburner.google.com/fb/a/mailverify?uri=<? echo get_option('sb_feedburner'); ?>&amp;loc=en_US">Subscribe by Email</a></li> <? } ?>
					<? if (get_option('sb_twitter')) { ?><li class="twitter"><a href="<? echo "http://twitter.com/".get_option('sb_twitter'); ?>">Follow me on Twitter</a></li> <? } ?>
				</ul>
			</div>
<?
}
function sb_widgets() {
	unregister_sidebar_widget('Calendar');
	unregister_sidebar_widget('Get Recent Trackbacks');
	register_sidebar_widget('RSS Feed Suscribe', 'sb_rss_widget');
}
add_action('widgets_init','sb_widgets');

	function sb_get_favicon() {
		$default_favicon = get_bloginfo('template_url')."/favicon.ico";
		$custom_favicon = get_option('sb_favicon');
		$favicon = (empty($custom_favicon)) ? $default_favicon : $custom_favicon;
		return $favicon;
	}

	function sb_get_logo() {
		$default_logo = get_bloginfo('template_url')."/images/logo.png";
		$custom_logo = get_option('sb_logo');
		$logo = (empty($custom_logo)) ? $default_logo : $custom_logo;
		return $logo;
	}
	
 function sbthemes_admin_head() { ?>
<style>
h2 { margin-bottom: 20px; }
.title { margin: 0px !important; background: #D4E9FA; padding: 10px; font-family: Georgia, serif; font-weight: normal !important; letter-spacing: 1px; font-size: 18px; }
.container { background: #EAF3FA; padding: 10px; }
.maintable { font-family:"Lucida Grande","Lucida Sans Unicode",Arial,Verdana,sans-serif; background: #EAF3FA; margin-bottom: 20px; padding: 10px 0px; }
.mainrow { padding-bottom: 10px !important; border-bottom: 1px solid #D4E9FA !important; float: left; margin: 0px 10px 10px 10px !important; }
.titledesc { font-size: 14px; font-weight:bold; width: 220px !important; margin-right: 20px !important; }
.forminp { width: 700px !important; valign: middle !important; }
.forminp input, .forminp select, .forminp textarea { margin-bottom: 9px !important; background: #fff; border: 1px solid #D4E9FA; width: 500px; padding: 4px; font-family:"Lucida Grande","Lucida Sans Unicode",Arial,Verdana,sans-serif; font-size: 12px; }
.forminp span { font-size: 10px !important; font-weight: normal !important; ine-height: 14px !important; }
.info { background: #FFFFCC; border: 1px dotted #D8D2A9; padding: 10px; color: #333; }
.forminp .checkbox { width:20px }
.info a { color: #333; text-decoration: none; border-bottom: 1px dotted #333 }
.info a:hover { color: #666; border-bottom: 1px dotted #666; }
.warning { background: #FFEBE8; border: 1px dotted #CC0000; padding: 10px; color: #333; font-weight: bold; }
</style>
<?php }
 
 // VARIABLES
 
$themename = "SimpleBlog";
$shortname = "sb";

$options = array();

$template_path = get_bloginfo('template_directory');

$sb_categories_obj = get_categories('hide_empty=0');
$sb_categories = array();

$sb_pages_obj = get_pages('sort_column=post_parent,menu_order');
$sb_pages = array();
	
	
// THIS IS THE DIFFERENT FIELDS
$options[] = array(	"name" => "Basic Options",
					"type" => "heading");
$options[] = array(	"name" => "Custom Logo",
					"desc" => "Paste the full URL of your custom logo image, should you wish to replace our default logo.",
					"id" => $shortname."_logo",
					"std" => "",
					"type" => "text");
$options[] = array(	"name" => "Custom Favicon",
					"desc" => "Paste the full URL of your custom favicon, should you wish to replace our default favicon.",
					"id" => $shortname."_favicon",
					"std" => "",
					"type" => "text");	
$options[] = array(	"name" => "FeedBurner URI",
					"desc" => "Paste the ONLY your FeedBurner URI.<br/>The bold text from the following URL: http://feeds2.feedburner.com/<strong>Slimmity</strong> <br/>This will replace RSS feed link on the sidebar.",
					"id" => $shortname."_feedburner",
					"std" => "",
					"type" => "text");
$options[] = array(	"name" => "Email Subscription",
					"desc" => "Check this if your Feedburner feed has email subscription enabled.",
					"id" => $shortname."_email",
					"std" => "",
					"type" => "checkbox");	
$options[] = array(	"name" => "Twitter URL",
					"desc" => "Paste your twitter user name. <br/>The bold text from the following URL: http://twitter.com/<strong>Slimmity</strong>",
					"id" => $shortname."_twitter",
					"std" => "",
					"type" => "text");										

// ADMIN PANEL

function sbthemes_add_admin() {

	 global $themename, $options;
	
	if ( $_GET['page'] == basename(__FILE__) ) {	
        if ( 'save' == $_REQUEST['action'] ) {
	
                foreach ($options as $value) {
					if($value['type'] != 'multicheck'){
                    	update_option( $value['id'], $_REQUEST[ $value['id'] ] ); 
					}else{
						foreach($value['options'] as $mc_key => $mc_value){
							$up_opt = $value['id'].'_'.$mc_key;
							update_option($up_opt, $_REQUEST[$up_opt] );
						}
					}
				}

                foreach ($options as $value) {
					if($value['type'] != 'multicheck'){
                    	if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } 
					}else{
						foreach($value['options'] as $mc_key => $mc_value){
							$up_opt = $value['id'].'_'.$mc_key;						
							if( isset( $_REQUEST[ $up_opt ] ) ) { update_option( $up_opt, $_REQUEST[ $up_opt ]  ); } else { delete_option( $up_opt ); } 
						}
					}
				}
						
				header("Location: admin.php?page=functions.php&saved=true");								
			
			die;

		} else if ( 'reset' == $_REQUEST['action'] ) {
			delete_option('sandbox_logo');
			
			header("Location: admin.php?page=functions.php&reset=true");
			die;
		}

	}
add_menu_page($themename." Options", $themename." Options", 'edit_themes', basename(__FILE__), 'sbthemes_page');
}

function sbthemes_page (){

		global $options, $themename, $manualurl;
		
		?>

<div class="wrap">

    			<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">

						<h2><?php echo $themename; ?> Options</h2>

						<?php if ( $_REQUEST['saved'] ) { ?><div style="clear:both;height:20px;"></div><div class="warning"><?php echo $themename; ?>'s Options has been updated!</div><?php } ?>
						<?php if ( $_REQUEST['reset'] ) { ?><div style="clear:both;height:20px;"></div><div class="warning"><?php echo $themename; ?>'s Options has been reset!</div><?php } ?>							
						
						<!--START: GENERAL SETTINGS-->
     						
     						<table class="maintable">
     							
							<?php foreach ($options as $value) { ?>
	
									<?php if ( $value['type'] <> "heading" ) { ?>
	
										<tr class="mainrow">
										<td class="titledesc"><?php echo $value['name']; ?></td>
										<td class="forminp">
		
									<?php } ?>		 
	
									<?php
										
										switch ( $value['type'] ) {
										case 'text':
		
									?>
									
		        							<input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings($value['id']); } else { echo $value['std']; } ?>" />
		
									<?php
										
										break;
										case 'select':
		
									?>
		
	            						<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
	                					<?php foreach ($value['options'] as $option) { ?>
	                						<option<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option>
	                					<?php } ?>
	            						</select>
		
									<?php
		
										break;
										case 'textarea':
										$ta_options = $value['options'];
		
									?>
									
										<textarea name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" cols="<?php echo $ta_options['cols']; ?>" rows="8"><?php  if( get_settings($value['id']) != "") { echo stripslashes(get_settings($value['id'])); } else { echo $value['std']; } ?></textarea>
		
									<?php
										
										break;
										case "radio":
		
 										foreach ($value['options'] as $key=>$option) { 
				
													$radio_setting = get_settings($value['id']);
													
													if($radio_setting != '') {
		    											
		    											if ($key == get_settings($value['id']) ) { $checked = "checked=\"checked\""; } else { $checked = ""; }
													
													} else {
													
														if($key == $value['std']) { $checked = "checked=\"checked\""; } else { $checked = ""; }
									} ?>
									
	            					<input type="radio" name="<?php echo $value['id']; ?>" value="<?php echo $key; ?>" <?php echo $checked; ?> /><?php echo $option; ?><br />
		
									<?php }
		 
										break;
										case "checkbox":
										
										if(get_settings($value['id'])) { $checked = "checked=\"checked\""; } else { $checked = ""; }
									
									?>
		            				
		            				<input type="checkbox" class="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />
		
									<?php
		
										break;
										case "multicheck":
		
 										foreach ($value['options'] as $key=>$option) {
 										
	 											$sb_key = $value['id'] . '_' . $key;
												$checkbox_setting = get_settings($sb_key);
				
 												if($checkbox_setting != '') {
		    		
		    											if (get_settings($sb_key) ) { $checked = "checked=\"checked\""; } else { $checked = ""; }
				
												} else { if($key == $value['std']) { $checked = "checked=\"checked\""; } else { $checked = ""; }
				
									} ?>
									
	            					<input type="checkbox" class="checkbox" name="<?php echo $sb_key; ?>" id="<?php echo $sb_key; ?>" value="true" <?php echo $checked; ?> /><label for="<?php echo $sb_key; ?>"><?php echo $option; ?></label><br />
									
									<?php }
		 
										break;
										case "heading":

									?>
									
										</table> 
		    							
		    									<h3 class="title"><?php echo $value['name']; ?></h3>
										
										<table class="maintable">
		
									<?php
										
										break;
										default:
										break;
									
									} ?>
	
									<?php if ( $value['type'] <> "heading" ) { ?>
	
										<?php if ( $value['type'] <> "checkbox" ) { ?><br/><?php } ?><span><?php echo $value['desc']; ?></span>
										</td></tr>
	
									<?php } ?>		
	
							<?php } ?>	
							
							</table>	

							<p class="submit">
								<input name="save" type="submit" value="Save changes" />    
								<input type="hidden" name="action" value="save" />
							</p>							
							
							<div style="clear:both;"></div>		
						
						<!--END: GENERAL SETTINGS-->						
             
            </form>

</div><!--wrap-->

<div style="clear:both;height:20px;"></div>
 
 <?php

};

$theme_metaboxes = array(
		"thumb-small" => array (
			"name"		=> "thumb-small",
			"default" 	=> "",
			"label" 	=> "Small Preview Image URL",
			"type" 		=> "text",
			"desc"      => "Upload your image with 'Add Media' above post window, copy the url and paste it here. Max height and width should be: 268x158 pixels"
		),
		"thumb-large" => array (
			"name"		=> "thumb-large",
			"default" 	=> "",
			"label" 	=> "Large Preview Image URL",
			"type" 		=> "text",
			"desc"      => "Upload your image with 'Add Media' above post window, copy the url and paste it here. Max height and width should be: 710x255 pixels"
		),
	);
	
add_action('admin_menu', 'sbthemes_add_admin');
add_action('admin_head', 'sbthemes_admin_head');	
	
?>
